<?php

namespace FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromReply StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromReply
 * @subpackage Structs
 */
class CreateFromReply extends AbstractStructBase
{
    /**
     * The DocumentCreated
     * @var bool
     */
    public $DocumentCreated;
    /**
     * The Documents
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromReplyDocumentCollection
     */
    public $Documents;
    /**
     * Constructor method for CreateFromReply
     * @uses CreateFromReply::setDocumentCreated()
     * @uses CreateFromReply::setDocuments()
     * @param bool $documentCreated
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromReplyDocumentCollection $documents
     */
    public function __construct($documentCreated = null, \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromReplyDocumentCollection $documents = null)
    {
        $this
            ->setDocumentCreated($documentCreated)
            ->setDocuments($documents);
    }
    /**
     * Get DocumentCreated value
     * @return bool|null
     */
    public function getDocumentCreated()
    {
        return $this->DocumentCreated;
    }
    /**
     * Set DocumentCreated value
     * @param bool $documentCreated
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromReply
     */
    public function setDocumentCreated($documentCreated = null)
    {
        // validation for constraint: boolean
        if (!is_null($documentCreated) && !is_bool($documentCreated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($documentCreated, true), gettype($documentCreated)), __LINE__);
        }
        $this->DocumentCreated = $documentCreated;
        return $this;
    }
    /**
     * Get Documents value
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromReplyDocumentCollection|null
     */
    public function getDocuments()
    {
        return $this->Documents;
    }
    /**
     * Set Documents value
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromReplyDocumentCollection $documents
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromReply
     */
    public function setDocuments(\FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromReplyDocumentCollection $documents = null)
    {
        $this->Documents = $documents;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromReply
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
