<?php

namespace FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromRequestHeaderUserDefinedDateCollection
 * StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromRequestHeaderUserDefinedDateCollection
 * @subpackage Structs
 */
class CreateFromRequestHeaderUserDefinedDateCollection extends AbstractStructBase
{
    /**
     * The UserDefinedDate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDate[]
     */
    public $UserDefinedDate;
    /**
     * Constructor method for CreateFromRequestHeaderUserDefinedDateCollection
     * @uses CreateFromRequestHeaderUserDefinedDateCollection::setUserDefinedDate()
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDate[] $userDefinedDate
     */
    public function __construct(array $userDefinedDate = array())
    {
        $this
            ->setUserDefinedDate($userDefinedDate);
    }
    /**
     * Get UserDefinedDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDate[]|null
     */
    public function getUserDefinedDate()
    {
        return isset($this->UserDefinedDate) ? $this->UserDefinedDate : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUserDefinedDate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserDefinedDate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserDefinedDateForArrayConstraintsFromSetUserDefinedDate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createFromRequestHeaderUserDefinedDateCollectionUserDefinedDateItem) {
            // validation for constraint: itemType
            if (!$createFromRequestHeaderUserDefinedDateCollectionUserDefinedDateItem instanceof \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDate) {
                $invalidValues[] = is_object($createFromRequestHeaderUserDefinedDateCollectionUserDefinedDateItem) ? get_class($createFromRequestHeaderUserDefinedDateCollectionUserDefinedDateItem) : sprintf('%s(%s)', gettype($createFromRequestHeaderUserDefinedDateCollectionUserDefinedDateItem), var_export($createFromRequestHeaderUserDefinedDateCollectionUserDefinedDateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserDefinedDate property can only contain items of type \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserDefinedDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDate[] $userDefinedDate
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDateCollection
     */
    public function setUserDefinedDate(array $userDefinedDate = array())
    {
        // validation for constraint: array
        if ('' !== ($userDefinedDateArrayErrorMessage = self::validateUserDefinedDateForArrayConstraintsFromSetUserDefinedDate($userDefinedDate))) {
            throw new \InvalidArgumentException($userDefinedDateArrayErrorMessage, __LINE__);
        }
        if (is_null($userDefinedDate) || (is_array($userDefinedDate) && empty($userDefinedDate))) {
            unset($this->UserDefinedDate);
        } else {
            $this->UserDefinedDate = $userDefinedDate;
        }
        return $this;
    }
    /**
     * Add item to UserDefinedDate value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDate $item
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDateCollection
     */
    public function addToUserDefinedDate(\FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDate) {
            throw new \InvalidArgumentException(sprintf('The UserDefinedDate property can only contain items of type \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserDefinedDate[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedDateCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
