<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUserDefinedBoolean ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: q25:ArrayOfUserDefinedBoolean
 * @subpackage Arrays
 */
class ArrayOfUserDefinedBoolean extends AbstractStructArrayBase
{
    /**
     * The UserDefinedBoolean
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean[]
     */
    public $UserDefinedBoolean;
    /**
     * Constructor method for ArrayOfUserDefinedBoolean
     * @uses ArrayOfUserDefinedBoolean::setUserDefinedBoolean()
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean[] $userDefinedBoolean
     */
    public function __construct(array $userDefinedBoolean = array())
    {
        $this
            ->setUserDefinedBoolean($userDefinedBoolean);
    }
    /**
     * Get UserDefinedBoolean value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean[]|null
     */
    public function getUserDefinedBoolean()
    {
        return isset($this->UserDefinedBoolean) ? $this->UserDefinedBoolean : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUserDefinedBoolean method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserDefinedBoolean method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserDefinedBooleanForArrayConstraintsFromSetUserDefinedBoolean(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUserDefinedBooleanUserDefinedBooleanItem) {
            // validation for constraint: itemType
            if (!$arrayOfUserDefinedBooleanUserDefinedBooleanItem instanceof \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean) {
                $invalidValues[] = is_object($arrayOfUserDefinedBooleanUserDefinedBooleanItem) ? get_class($arrayOfUserDefinedBooleanUserDefinedBooleanItem) : sprintf('%s(%s)', gettype($arrayOfUserDefinedBooleanUserDefinedBooleanItem), var_export($arrayOfUserDefinedBooleanUserDefinedBooleanItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserDefinedBoolean property can only contain items of type \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserDefinedBoolean value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean[] $userDefinedBoolean
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedBoolean
     */
    public function setUserDefinedBoolean(array $userDefinedBoolean = array())
    {
        // validation for constraint: array
        if ('' !== ($userDefinedBooleanArrayErrorMessage = self::validateUserDefinedBooleanForArrayConstraintsFromSetUserDefinedBoolean($userDefinedBoolean))) {
            throw new \InvalidArgumentException($userDefinedBooleanArrayErrorMessage, __LINE__);
        }
        if (is_null($userDefinedBoolean) || (is_array($userDefinedBoolean) && empty($userDefinedBoolean))) {
            unset($this->UserDefinedBoolean);
        } else {
            $this->UserDefinedBoolean = $userDefinedBoolean;
        }
        return $this;
    }
    /**
     * Add item to UserDefinedBoolean value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean $item
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedBoolean
     */
    public function addToUserDefinedBoolean(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean) {
            throw new \InvalidArgumentException(sprintf('The UserDefinedBoolean property can only contain items of type \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserDefinedBoolean[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UserDefinedBoolean
     */
    public function getAttributeName()
    {
        return 'UserDefinedBoolean';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedBoolean
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
