<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Add ServiceType
 * @subpackage Services
 */
class Add extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named AddNewCustomer
     * Meta information extracted from the WSDL
     * - documentation: Enables customer creation. Their number will be allocated automatically (requires to activate the automatic numbering in the user's store.) | Returns the identifier of the customer created.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddNewCustomer $parameters
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddNewCustomerResponse|bool
     */
    public function AddNewCustomer(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddNewCustomer $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->AddNewCustomer($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddNewCustomerResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
