<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserDefinedDataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Customizable user-defined customer data.
 * - nillable: true
 * - type: q29:UserDefinedDataType
 * @subpackage Structs
 */
class UserDefinedDataType extends AbstractStructBase
{
    /**
     * The UserDefinedTable0Value
     * Meta information extracted from the WSDL
     * - documentation: 1st customer user-defined data. - Related to column [TIERSCOMPL.YTC_TABLELIBRETIERS1].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserDefinedTable0Value;
    /**
     * The UserDefinedTable1Value
     * Meta information extracted from the WSDL
     * - documentation: 2nd customer user-defined data. - Related to column [TIERSCOMPL.YTC_TABLELIBRETIERS2].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserDefinedTable1Value;
    /**
     * The UserDefinedTable2Value
     * Meta information extracted from the WSDL
     * - documentation: 3rd customer user-defined data. - Related to column [TIERSCOMPL.YTC_TABLELIBRETIERS3].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserDefinedTable2Value;
    /**
     * The UserDefinedTable3Value
     * Meta information extracted from the WSDL
     * - documentation: 4th customer user-defined data. - Related to column [TIERSCOMPL.YTC_TABLELIBRETIERS4].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserDefinedTable3Value;
    /**
     * The UserDefinedTable4Value
     * Meta information extracted from the WSDL
     * - documentation: 5th customer user-defined data. - Related to column [TIERSCOMPL.YTC_TABLELIBRETIERS5].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserDefinedTable4Value;
    /**
     * The UserDefinedTable5Value
     * Meta information extracted from the WSDL
     * - documentation: 6th customer user-defined data. - Related to column [TIERSCOMPL.YTC_TABLELIBRETIERS6].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserDefinedTable5Value;
    /**
     * The UserDefinedTable6Value
     * Meta information extracted from the WSDL
     * - documentation: 7th customer user-defined data. - Related to column [TIERSCOMPL.YTC_TABLELIBRETIERS7].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserDefinedTable6Value;
    /**
     * The UserDefinedTable7Value
     * Meta information extracted from the WSDL
     * - documentation: 8th customer user-defined data. - Related to column [TIERSCOMPL.YTC_TABLELIBRETIERS8].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserDefinedTable7Value;
    /**
     * The UserDefinedTable8Value
     * Meta information extracted from the WSDL
     * - documentation: 9th customer user-defined data. - Related to column [TIERSCOMPL.YTC_TABLELIBRETIERS9].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserDefinedTable8Value;
    /**
     * The UserDefinedTable9Value
     * Meta information extracted from the WSDL
     * - documentation: 10th customer user-defined data. - Related to column [TIERSCOMPL.YTC_TABLELIBRETIERSA].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserDefinedTable9Value;
    /**
     * Constructor method for UserDefinedDataType
     * @uses UserDefinedDataType::setUserDefinedTable0Value()
     * @uses UserDefinedDataType::setUserDefinedTable1Value()
     * @uses UserDefinedDataType::setUserDefinedTable2Value()
     * @uses UserDefinedDataType::setUserDefinedTable3Value()
     * @uses UserDefinedDataType::setUserDefinedTable4Value()
     * @uses UserDefinedDataType::setUserDefinedTable5Value()
     * @uses UserDefinedDataType::setUserDefinedTable6Value()
     * @uses UserDefinedDataType::setUserDefinedTable7Value()
     * @uses UserDefinedDataType::setUserDefinedTable8Value()
     * @uses UserDefinedDataType::setUserDefinedTable9Value()
     * @param string $userDefinedTable0Value
     * @param string $userDefinedTable1Value
     * @param string $userDefinedTable2Value
     * @param string $userDefinedTable3Value
     * @param string $userDefinedTable4Value
     * @param string $userDefinedTable5Value
     * @param string $userDefinedTable6Value
     * @param string $userDefinedTable7Value
     * @param string $userDefinedTable8Value
     * @param string $userDefinedTable9Value
     */
    public function __construct($userDefinedTable0Value = null, $userDefinedTable1Value = null, $userDefinedTable2Value = null, $userDefinedTable3Value = null, $userDefinedTable4Value = null, $userDefinedTable5Value = null, $userDefinedTable6Value = null, $userDefinedTable7Value = null, $userDefinedTable8Value = null, $userDefinedTable9Value = null)
    {
        $this
            ->setUserDefinedTable0Value($userDefinedTable0Value)
            ->setUserDefinedTable1Value($userDefinedTable1Value)
            ->setUserDefinedTable2Value($userDefinedTable2Value)
            ->setUserDefinedTable3Value($userDefinedTable3Value)
            ->setUserDefinedTable4Value($userDefinedTable4Value)
            ->setUserDefinedTable5Value($userDefinedTable5Value)
            ->setUserDefinedTable6Value($userDefinedTable6Value)
            ->setUserDefinedTable7Value($userDefinedTable7Value)
            ->setUserDefinedTable8Value($userDefinedTable8Value)
            ->setUserDefinedTable9Value($userDefinedTable9Value);
    }
    /**
     * Get UserDefinedTable0Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserDefinedTable0Value()
    {
        return isset($this->UserDefinedTable0Value) ? $this->UserDefinedTable0Value : null;
    }
    /**
     * Set UserDefinedTable0Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userDefinedTable0Value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public function setUserDefinedTable0Value($userDefinedTable0Value = null)
    {
        // validation for constraint: string
        if (!is_null($userDefinedTable0Value) && !is_string($userDefinedTable0Value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userDefinedTable0Value, true), gettype($userDefinedTable0Value)), __LINE__);
        }
        if (is_null($userDefinedTable0Value) || (is_array($userDefinedTable0Value) && empty($userDefinedTable0Value))) {
            unset($this->UserDefinedTable0Value);
        } else {
            $this->UserDefinedTable0Value = $userDefinedTable0Value;
        }
        return $this;
    }
    /**
     * Get UserDefinedTable1Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserDefinedTable1Value()
    {
        return isset($this->UserDefinedTable1Value) ? $this->UserDefinedTable1Value : null;
    }
    /**
     * Set UserDefinedTable1Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userDefinedTable1Value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public function setUserDefinedTable1Value($userDefinedTable1Value = null)
    {
        // validation for constraint: string
        if (!is_null($userDefinedTable1Value) && !is_string($userDefinedTable1Value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userDefinedTable1Value, true), gettype($userDefinedTable1Value)), __LINE__);
        }
        if (is_null($userDefinedTable1Value) || (is_array($userDefinedTable1Value) && empty($userDefinedTable1Value))) {
            unset($this->UserDefinedTable1Value);
        } else {
            $this->UserDefinedTable1Value = $userDefinedTable1Value;
        }
        return $this;
    }
    /**
     * Get UserDefinedTable2Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserDefinedTable2Value()
    {
        return isset($this->UserDefinedTable2Value) ? $this->UserDefinedTable2Value : null;
    }
    /**
     * Set UserDefinedTable2Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userDefinedTable2Value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public function setUserDefinedTable2Value($userDefinedTable2Value = null)
    {
        // validation for constraint: string
        if (!is_null($userDefinedTable2Value) && !is_string($userDefinedTable2Value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userDefinedTable2Value, true), gettype($userDefinedTable2Value)), __LINE__);
        }
        if (is_null($userDefinedTable2Value) || (is_array($userDefinedTable2Value) && empty($userDefinedTable2Value))) {
            unset($this->UserDefinedTable2Value);
        } else {
            $this->UserDefinedTable2Value = $userDefinedTable2Value;
        }
        return $this;
    }
    /**
     * Get UserDefinedTable3Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserDefinedTable3Value()
    {
        return isset($this->UserDefinedTable3Value) ? $this->UserDefinedTable3Value : null;
    }
    /**
     * Set UserDefinedTable3Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userDefinedTable3Value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public function setUserDefinedTable3Value($userDefinedTable3Value = null)
    {
        // validation for constraint: string
        if (!is_null($userDefinedTable3Value) && !is_string($userDefinedTable3Value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userDefinedTable3Value, true), gettype($userDefinedTable3Value)), __LINE__);
        }
        if (is_null($userDefinedTable3Value) || (is_array($userDefinedTable3Value) && empty($userDefinedTable3Value))) {
            unset($this->UserDefinedTable3Value);
        } else {
            $this->UserDefinedTable3Value = $userDefinedTable3Value;
        }
        return $this;
    }
    /**
     * Get UserDefinedTable4Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserDefinedTable4Value()
    {
        return isset($this->UserDefinedTable4Value) ? $this->UserDefinedTable4Value : null;
    }
    /**
     * Set UserDefinedTable4Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userDefinedTable4Value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public function setUserDefinedTable4Value($userDefinedTable4Value = null)
    {
        // validation for constraint: string
        if (!is_null($userDefinedTable4Value) && !is_string($userDefinedTable4Value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userDefinedTable4Value, true), gettype($userDefinedTable4Value)), __LINE__);
        }
        if (is_null($userDefinedTable4Value) || (is_array($userDefinedTable4Value) && empty($userDefinedTable4Value))) {
            unset($this->UserDefinedTable4Value);
        } else {
            $this->UserDefinedTable4Value = $userDefinedTable4Value;
        }
        return $this;
    }
    /**
     * Get UserDefinedTable5Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserDefinedTable5Value()
    {
        return isset($this->UserDefinedTable5Value) ? $this->UserDefinedTable5Value : null;
    }
    /**
     * Set UserDefinedTable5Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userDefinedTable5Value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public function setUserDefinedTable5Value($userDefinedTable5Value = null)
    {
        // validation for constraint: string
        if (!is_null($userDefinedTable5Value) && !is_string($userDefinedTable5Value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userDefinedTable5Value, true), gettype($userDefinedTable5Value)), __LINE__);
        }
        if (is_null($userDefinedTable5Value) || (is_array($userDefinedTable5Value) && empty($userDefinedTable5Value))) {
            unset($this->UserDefinedTable5Value);
        } else {
            $this->UserDefinedTable5Value = $userDefinedTable5Value;
        }
        return $this;
    }
    /**
     * Get UserDefinedTable6Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserDefinedTable6Value()
    {
        return isset($this->UserDefinedTable6Value) ? $this->UserDefinedTable6Value : null;
    }
    /**
     * Set UserDefinedTable6Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userDefinedTable6Value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public function setUserDefinedTable6Value($userDefinedTable6Value = null)
    {
        // validation for constraint: string
        if (!is_null($userDefinedTable6Value) && !is_string($userDefinedTable6Value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userDefinedTable6Value, true), gettype($userDefinedTable6Value)), __LINE__);
        }
        if (is_null($userDefinedTable6Value) || (is_array($userDefinedTable6Value) && empty($userDefinedTable6Value))) {
            unset($this->UserDefinedTable6Value);
        } else {
            $this->UserDefinedTable6Value = $userDefinedTable6Value;
        }
        return $this;
    }
    /**
     * Get UserDefinedTable7Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserDefinedTable7Value()
    {
        return isset($this->UserDefinedTable7Value) ? $this->UserDefinedTable7Value : null;
    }
    /**
     * Set UserDefinedTable7Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userDefinedTable7Value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public function setUserDefinedTable7Value($userDefinedTable7Value = null)
    {
        // validation for constraint: string
        if (!is_null($userDefinedTable7Value) && !is_string($userDefinedTable7Value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userDefinedTable7Value, true), gettype($userDefinedTable7Value)), __LINE__);
        }
        if (is_null($userDefinedTable7Value) || (is_array($userDefinedTable7Value) && empty($userDefinedTable7Value))) {
            unset($this->UserDefinedTable7Value);
        } else {
            $this->UserDefinedTable7Value = $userDefinedTable7Value;
        }
        return $this;
    }
    /**
     * Get UserDefinedTable8Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserDefinedTable8Value()
    {
        return isset($this->UserDefinedTable8Value) ? $this->UserDefinedTable8Value : null;
    }
    /**
     * Set UserDefinedTable8Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userDefinedTable8Value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public function setUserDefinedTable8Value($userDefinedTable8Value = null)
    {
        // validation for constraint: string
        if (!is_null($userDefinedTable8Value) && !is_string($userDefinedTable8Value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userDefinedTable8Value, true), gettype($userDefinedTable8Value)), __LINE__);
        }
        if (is_null($userDefinedTable8Value) || (is_array($userDefinedTable8Value) && empty($userDefinedTable8Value))) {
            unset($this->UserDefinedTable8Value);
        } else {
            $this->UserDefinedTable8Value = $userDefinedTable8Value;
        }
        return $this;
    }
    /**
     * Get UserDefinedTable9Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserDefinedTable9Value()
    {
        return isset($this->UserDefinedTable9Value) ? $this->UserDefinedTable9Value : null;
    }
    /**
     * Set UserDefinedTable9Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userDefinedTable9Value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public function setUserDefinedTable9Value($userDefinedTable9Value = null)
    {
        // validation for constraint: string
        if (!is_null($userDefinedTable9Value) && !is_string($userDefinedTable9Value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userDefinedTable9Value, true), gettype($userDefinedTable9Value)), __LINE__);
        }
        if (is_null($userDefinedTable9Value) || (is_array($userDefinedTable9Value) && empty($userDefinedTable9Value))) {
            unset($this->UserDefinedTable9Value);
        } else {
            $this->UserDefinedTable9Value = $userDefinedTable9Value;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDataType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
