<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetAvailableQtyResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Returns the quantity available in stock for an item without dimension or SKU.
 * @subpackage Structs
 */
class GetAvailableQtyResponse extends AbstractStructBase
{
    /**
     * The GetAvailableQtyResult
     * Meta information extracted from the WSDL
     * - documentation: Returns the quantity available in stock. Value 0 is returned if the item identifier or the warehouse identifier are incorrect.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn
     */
    public $GetAvailableQtyResult;
    /**
     * Constructor method for GetAvailableQtyResponse
     * @uses GetAvailableQtyResponse::setGetAvailableQtyResult()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn $getAvailableQtyResult
     */
    public function __construct(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn $getAvailableQtyResult = null)
    {
        $this
            ->setGetAvailableQtyResult($getAvailableQtyResult);
    }
    /**
     * Get GetAvailableQtyResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn|null
     */
    public function getGetAvailableQtyResult()
    {
        return isset($this->GetAvailableQtyResult) ? $this->GetAvailableQtyResult : null;
    }
    /**
     * Set GetAvailableQtyResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn $getAvailableQtyResult
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQtyResponse
     */
    public function setGetAvailableQtyResult(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn $getAvailableQtyResult = null)
    {
        if (is_null($getAvailableQtyResult) || (is_array($getAvailableQtyResult) && empty($getAvailableQtyResult))) {
            unset($this->GetAvailableQtyResult);
        } else {
            $this->GetAvailableQtyResult = $getAvailableQtyResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQtyResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
