<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetListItemInventoryDetailByStore_Request StructType
 * Meta information extracted from the WSDL
 * - documentation: [Added 2013/10 - V1104] - Object used to convey data to get the item inventory detail by store
 * - nillable: true
 * - type: tns:GetListItemInventoryDetailByStore_Request
 * @subpackage Structs
 */
class GetListItemInventoryDetailByStore_Request extends AbstractStructBase
{
    /**
     * The AllAvailableWarehouse
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/10 - V1104] [Optional] - With warehouses visible to other stores? Otherwise, only the inventory of the store's main warehouse is visible - Default value: False.
     * - minOccurs: 0
     * @var bool
     */
    public $AllAvailableWarehouse;
    /**
     * The DetailSku
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/10 - V1104] [Optional] - If this is a generic item, should the application detail SKUs and their inventory ? - Default value: False.
     * - minOccurs: 0
     * @var bool
     */
    public $DetailSku;
    /**
     * The ItemIdentifiers
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/10 - V1104] - List of items to inventory. The item can be generic (GEN), single (UNI) or dimensioned (DIM).
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfItemIdentifier
     */
    public $ItemIdentifiers;
    /**
     * The OnlyAvailableStock
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/10 - V1104] [Optional] - Only data with positive inventory ? - Default value: False.
     * - minOccurs: 0
     * @var bool
     */
    public $OnlyAvailableStock;
    /**
     * The Pager
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/10 - V1104] [Optional] - Paging object.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\Pager
     */
    public $Pager;
    /**
     * The StoreIds
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/10 - V1104] [Optional] - List of stores which inventory is to be returned. - Default behavior: Otherwise, inventory from all the stores accessible to the current user will be returned. - Related to column
     * [ETABLISS.ET_ETABLISSEMENT].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfstring
     */
    public $StoreIds;
    /**
     * The WithStoreName
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/10 - V1104] [Optional] - Should we get the name of the store? - Default value: False.
     * - minOccurs: 0
     * @var bool
     */
    public $WithStoreName;
    /**
     * Constructor method for GetListItemInventoryDetailByStore_Request
     * @uses GetListItemInventoryDetailByStore_Request::setAllAvailableWarehouse()
     * @uses GetListItemInventoryDetailByStore_Request::setDetailSku()
     * @uses GetListItemInventoryDetailByStore_Request::setItemIdentifiers()
     * @uses GetListItemInventoryDetailByStore_Request::setOnlyAvailableStock()
     * @uses GetListItemInventoryDetailByStore_Request::setPager()
     * @uses GetListItemInventoryDetailByStore_Request::setStoreIds()
     * @uses GetListItemInventoryDetailByStore_Request::setWithStoreName()
     * @param bool $allAvailableWarehouse
     * @param bool $detailSku
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfItemIdentifier $itemIdentifiers
     * @param bool $onlyAvailableStock
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\Pager $pager
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfstring $storeIds
     * @param bool $withStoreName
     */
    public function __construct($allAvailableWarehouse = null, $detailSku = null, \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfItemIdentifier $itemIdentifiers = null, $onlyAvailableStock = null, \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\Pager $pager = null, \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfstring $storeIds = null, $withStoreName = null)
    {
        $this
            ->setAllAvailableWarehouse($allAvailableWarehouse)
            ->setDetailSku($detailSku)
            ->setItemIdentifiers($itemIdentifiers)
            ->setOnlyAvailableStock($onlyAvailableStock)
            ->setPager($pager)
            ->setStoreIds($storeIds)
            ->setWithStoreName($withStoreName);
    }
    /**
     * Get AllAvailableWarehouse value
     * @return bool|null
     */
    public function getAllAvailableWarehouse()
    {
        return $this->AllAvailableWarehouse;
    }
    /**
     * Set AllAvailableWarehouse value
     * @param bool $allAvailableWarehouse
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request
     */
    public function setAllAvailableWarehouse($allAvailableWarehouse = null)
    {
        // validation for constraint: boolean
        if (!is_null($allAvailableWarehouse) && !is_bool($allAvailableWarehouse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($allAvailableWarehouse, true), gettype($allAvailableWarehouse)), __LINE__);
        }
        $this->AllAvailableWarehouse = $allAvailableWarehouse;
        return $this;
    }
    /**
     * Get DetailSku value
     * @return bool|null
     */
    public function getDetailSku()
    {
        return $this->DetailSku;
    }
    /**
     * Set DetailSku value
     * @param bool $detailSku
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request
     */
    public function setDetailSku($detailSku = null)
    {
        // validation for constraint: boolean
        if (!is_null($detailSku) && !is_bool($detailSku)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($detailSku, true), gettype($detailSku)), __LINE__);
        }
        $this->DetailSku = $detailSku;
        return $this;
    }
    /**
     * Get ItemIdentifiers value
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfItemIdentifier|null
     */
    public function getItemIdentifiers()
    {
        return $this->ItemIdentifiers;
    }
    /**
     * Set ItemIdentifiers value
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfItemIdentifier $itemIdentifiers
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request
     */
    public function setItemIdentifiers(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfItemIdentifier $itemIdentifiers = null)
    {
        $this->ItemIdentifiers = $itemIdentifiers;
        return $this;
    }
    /**
     * Get OnlyAvailableStock value
     * @return bool|null
     */
    public function getOnlyAvailableStock()
    {
        return $this->OnlyAvailableStock;
    }
    /**
     * Set OnlyAvailableStock value
     * @param bool $onlyAvailableStock
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request
     */
    public function setOnlyAvailableStock($onlyAvailableStock = null)
    {
        // validation for constraint: boolean
        if (!is_null($onlyAvailableStock) && !is_bool($onlyAvailableStock)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($onlyAvailableStock, true), gettype($onlyAvailableStock)), __LINE__);
        }
        $this->OnlyAvailableStock = $onlyAvailableStock;
        return $this;
    }
    /**
     * Get Pager value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\Pager|null
     */
    public function getPager()
    {
        return isset($this->Pager) ? $this->Pager : null;
    }
    /**
     * Set Pager value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\Pager $pager
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request
     */
    public function setPager(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\Pager $pager = null)
    {
        if (is_null($pager) || (is_array($pager) && empty($pager))) {
            unset($this->Pager);
        } else {
            $this->Pager = $pager;
        }
        return $this;
    }
    /**
     * Get StoreIds value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfstring|null
     */
    public function getStoreIds()
    {
        return isset($this->StoreIds) ? $this->StoreIds : null;
    }
    /**
     * Set StoreIds value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfstring $storeIds
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request
     */
    public function setStoreIds(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfstring $storeIds = null)
    {
        if (is_null($storeIds) || (is_array($storeIds) && empty($storeIds))) {
            unset($this->StoreIds);
        } else {
            $this->StoreIds = $storeIds;
        }
        return $this;
    }
    /**
     * Get WithStoreName value
     * @return bool|null
     */
    public function getWithStoreName()
    {
        return $this->WithStoreName;
    }
    /**
     * Set WithStoreName value
     * @param bool $withStoreName
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request
     */
    public function setWithStoreName($withStoreName = null)
    {
        // validation for constraint: boolean
        if (!is_null($withStoreName) && !is_bool($withStoreName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($withStoreName, true), gettype($withStoreName)), __LINE__);
        }
        $this->WithStoreName = $withStoreName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
