<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Create ServiceType
 * @subpackage Services
 */
class Create extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named CreateLoyaltyCard
     * Meta information extracted from the WSDL
     * - documentation: Enables the creation of a loyalty card. | Reference enabling the identification of the customer. - Related to column [MCARETFIDENT.MFC_TIERS] | Returns the number of the card created. - Related to column [MCARETFIDENT.MFC_NUMCARTE]
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateLoyaltyCard $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateLoyaltyCardResponse|bool
     */
    public function CreateLoyaltyCard(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateLoyaltyCard $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CreateLoyaltyCard($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named CreateExternCard
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/04 - V1110] [Beta] - Allows the creation of a loyalty card from an external system
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCard $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardResponse|bool
     */
    public function CreateExternCard(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCard $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CreateExternCard($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateLoyaltyCardResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
