<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Update ServiceType
 * @subpackage Services
 */
class Update extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named UpdatePoints
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/10 - V1104] [Beta] - Enables the update of points on a given loyalty card.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePoints $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsResponse|bool
     */
    public function UpdatePoints(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePoints $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->UpdatePoints($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named UpdateProgram
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/04 - V1110] [Beta] - Allows the update of the loyalty program on the customer's card
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateProgram $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateProgramResponse|bool
     */
    public function UpdateProgram(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateProgram $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->UpdateProgram($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named UpdateValidityPeriod
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/04 - V1110] [Beta] - Allows the update of the validity dates on the customer's card
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateValidityPeriod $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateValidityPeriodResponse|bool
     */
    public function UpdateValidityPeriod(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateValidityPeriod $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->UpdateValidityPeriod($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named UpdateCardId
     * Meta information extracted from the WSDL
     * - documentation: [Added 2016/04 - V1110] [Beta] - Allows the card number to be updated
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateCardId $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateCardIdResponse|bool
     */
    public function UpdateCardId(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateCardId $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->UpdateCardId($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateCardIdResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateProgramResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateValidityPeriodResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
