<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetLoyaltyPointsForSaleResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: [Added 2013/05 - V1102] - Returns the loyalty points earned for an existing sales document.
 * @subpackage Structs
 */
class GetLoyaltyPointsForSaleResponse extends AbstractStructBase
{
    /**
     * The GetLoyaltyPointsForSaleResult
     * Meta information extracted from the WSDL
     * - documentation: Loyalty points earned
     * - minOccurs: 0
     * @var float
     */
    public $GetLoyaltyPointsForSaleResult;
    /**
     * Constructor method for GetLoyaltyPointsForSaleResponse
     * @uses GetLoyaltyPointsForSaleResponse::setGetLoyaltyPointsForSaleResult()
     * @param float $getLoyaltyPointsForSaleResult
     */
    public function __construct($getLoyaltyPointsForSaleResult = null)
    {
        $this
            ->setGetLoyaltyPointsForSaleResult($getLoyaltyPointsForSaleResult);
    }
    /**
     * Get GetLoyaltyPointsForSaleResult value
     * @return float|null
     */
    public function getGetLoyaltyPointsForSaleResult()
    {
        return $this->GetLoyaltyPointsForSaleResult;
    }
    /**
     * Set GetLoyaltyPointsForSaleResult value
     * @param float $getLoyaltyPointsForSaleResult
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSaleResponse
     */
    public function setGetLoyaltyPointsForSaleResult($getLoyaltyPointsForSaleResult = null)
    {
        // validation for constraint: float
        if (!is_null($getLoyaltyPointsForSaleResult) && !(is_float($getLoyaltyPointsForSaleResult) || is_numeric($getLoyaltyPointsForSaleResult))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($getLoyaltyPointsForSaleResult, true), gettype($getLoyaltyPointsForSaleResult)), __LINE__);
        }
        $this->GetLoyaltyPointsForSaleResult = $getLoyaltyPointsForSaleResult;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSaleResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
