<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReOpenCard StructType
 * Meta information extracted from the WSDL
 * - documentation: [Added 2016/04 - V1110] [Beta] - Allows a closed card to be reopened
 * @subpackage Structs
 */
class ReOpenCard extends AbstractStructBase
{
    /**
     * The ReOpenCardRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ReOpenCardRequest
     */
    public $ReOpenCardRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for ReOpenCard
     * @uses ReOpenCard::setReOpenCardRequest()
     * @uses ReOpenCard::setClientContext()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ReOpenCardRequest $reOpenCardRequest
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ReOpenCardRequest $reOpenCardRequest = null, \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setReOpenCardRequest($reOpenCardRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get ReOpenCardRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ReOpenCardRequest|null
     */
    public function getReOpenCardRequest()
    {
        return isset($this->ReOpenCardRequest) ? $this->ReOpenCardRequest : null;
    }
    /**
     * Set ReOpenCardRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ReOpenCardRequest $reOpenCardRequest
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ReOpenCard
     */
    public function setReOpenCardRequest(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ReOpenCardRequest $reOpenCardRequest = null)
    {
        if (is_null($reOpenCardRequest) || (is_array($reOpenCardRequest) && empty($reOpenCardRequest))) {
            unset($this->ReOpenCardRequest);
        } else {
            $this->ReOpenCardRequest = $reOpenCardRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ReOpenCard
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ReOpenCard
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
