<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateValidityPeriodRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Update of the validity dates for a loyalty card
 * - nillable: true
 * - type: tns:UpdateValidityPeriodRequest
 * @subpackage Structs
 */
class UpdateValidityPeriodRequest extends AbstractStructBase
{
    /**
     * The LoyaltyCardId
     * Meta information extracted from the WSDL
     * - documentation: Loyalty card number - Related to column [MCARTEFIDENT.MFC_NUMCARTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LoyaltyCardId;
    /**
     * The ValidityPeriod
     * Meta information extracted from the WSDL
     * - documentation: Validity dates for the loyalty card.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType
     */
    public $ValidityPeriod;
    /**
     * Constructor method for UpdateValidityPeriodRequest
     * @uses UpdateValidityPeriodRequest::setLoyaltyCardId()
     * @uses UpdateValidityPeriodRequest::setValidityPeriod()
     * @param string $loyaltyCardId
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType $validityPeriod
     */
    public function __construct($loyaltyCardId = null, \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType $validityPeriod = null)
    {
        $this
            ->setLoyaltyCardId($loyaltyCardId)
            ->setValidityPeriod($validityPeriod);
    }
    /**
     * Get LoyaltyCardId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLoyaltyCardId()
    {
        return isset($this->LoyaltyCardId) ? $this->LoyaltyCardId : null;
    }
    /**
     * Set LoyaltyCardId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $loyaltyCardId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateValidityPeriodRequest
     */
    public function setLoyaltyCardId($loyaltyCardId = null)
    {
        // validation for constraint: string
        if (!is_null($loyaltyCardId) && !is_string($loyaltyCardId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loyaltyCardId, true), gettype($loyaltyCardId)), __LINE__);
        }
        if (is_null($loyaltyCardId) || (is_array($loyaltyCardId) && empty($loyaltyCardId))) {
            unset($this->LoyaltyCardId);
        } else {
            $this->LoyaltyCardId = $loyaltyCardId;
        }
        return $this;
    }
    /**
     * Get ValidityPeriod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType|null
     */
    public function getValidityPeriod()
    {
        return isset($this->ValidityPeriod) ? $this->ValidityPeriod : null;
    }
    /**
     * Set ValidityPeriod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType $validityPeriod
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateValidityPeriodRequest
     */
    public function setValidityPeriod(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ValidityPeriodType $validityPeriod = null)
    {
        if (is_null($validityPeriod) || (is_array($validityPeriod) && empty($validityPeriod))) {
            unset($this->ValidityPeriod);
        } else {
            $this->ValidityPeriod = $validityPeriod;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateValidityPeriodRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
