<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSaleDocumentType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSaleDocumentType
 * @subpackage Arrays
 */
class ArrayOfSaleDocumentType extends AbstractStructArrayBase
{
    /**
     * The SaleDocumentType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $SaleDocumentType;
    /**
     * Constructor method for ArrayOfSaleDocumentType
     * @uses ArrayOfSaleDocumentType::setSaleDocumentType()
     * @param string[] $saleDocumentType
     */
    public function __construct(array $saleDocumentType = array())
    {
        $this
            ->setSaleDocumentType($saleDocumentType);
    }
    /**
     * Get SaleDocumentType value
     * @return string[]|null
     */
    public function getSaleDocumentType()
    {
        return $this->SaleDocumentType;
    }
    /**
     * This method is responsible for validating the values passed to the setSaleDocumentType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSaleDocumentType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSaleDocumentTypeForArrayConstraintsFromSetSaleDocumentType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSaleDocumentTypeSaleDocumentTypeItem) {
            // validation for constraint: enumeration
            if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType::valueIsValid($arrayOfSaleDocumentTypeSaleDocumentTypeItem)) {
                $invalidValues[] = is_object($arrayOfSaleDocumentTypeSaleDocumentTypeItem) ? get_class($arrayOfSaleDocumentTypeSaleDocumentTypeItem) : sprintf('%s(%s)', gettype($arrayOfSaleDocumentTypeSaleDocumentTypeItem), var_export($arrayOfSaleDocumentTypeSaleDocumentTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SaleDocumentType value
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $saleDocumentType
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfSaleDocumentType
     */
    public function setSaleDocumentType(array $saleDocumentType = array())
    {
        // validation for constraint: array
        if ('' !== ($saleDocumentTypeArrayErrorMessage = self::validateSaleDocumentTypeForArrayConstraintsFromSetSaleDocumentType($saleDocumentType))) {
            throw new \InvalidArgumentException($saleDocumentTypeArrayErrorMessage, __LINE__);
        }
        $this->SaleDocumentType = $saleDocumentType;
        return $this;
    }
    /**
     * Add item to SaleDocumentType value
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfSaleDocumentType
     */
    public function addToSaleDocumentType($item)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType::getValidValues())), __LINE__);
        }
        $this->SaleDocumentType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType::valueIsValid()
     * @param string $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfSaleDocumentType
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\SaleDocumentType::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SaleDocumentType
     */
    public function getAttributeName()
    {
        return 'SaleDocumentType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfSaleDocumentType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
