<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUpdate_Line ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUpdate_Line
 * @subpackage Arrays
 */
class ArrayOfUpdate_Line extends AbstractStructArrayBase
{
    /**
     * The Update_Line
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line[]
     */
    public $Update_Line;
    /**
     * Constructor method for ArrayOfUpdate_Line
     * @uses ArrayOfUpdate_Line::setUpdate_Line()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line[] $update_Line
     */
    public function __construct(array $update_Line = array())
    {
        $this
            ->setUpdate_Line($update_Line);
    }
    /**
     * Get Update_Line value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line[]|null
     */
    public function getUpdate_Line()
    {
        return isset($this->Update_Line) ? $this->Update_Line : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdate_Line method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdate_Line method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdate_LineForArrayConstraintsFromSetUpdate_Line(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUpdate_LineUpdate_LineItem) {
            // validation for constraint: itemType
            if (!$arrayOfUpdate_LineUpdate_LineItem instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line) {
                $invalidValues[] = is_object($arrayOfUpdate_LineUpdate_LineItem) ? get_class($arrayOfUpdate_LineUpdate_LineItem) : sprintf('%s(%s)', gettype($arrayOfUpdate_LineUpdate_LineItem), var_export($arrayOfUpdate_LineUpdate_LineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Update_Line property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Update_Line value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line[] $update_Line
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Line
     */
    public function setUpdate_Line(array $update_Line = array())
    {
        // validation for constraint: array
        if ('' !== ($update_LineArrayErrorMessage = self::validateUpdate_LineForArrayConstraintsFromSetUpdate_Line($update_Line))) {
            throw new \InvalidArgumentException($update_LineArrayErrorMessage, __LINE__);
        }
        if (is_null($update_Line) || (is_array($update_Line) && empty($update_Line))) {
            unset($this->Update_Line);
        } else {
            $this->Update_Line = $update_Line;
        }
        return $this;
    }
    /**
     * Add item to Update_Line value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Line
     */
    public function addToUpdate_Line(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line) {
            throw new \InvalidArgumentException(sprintf('The Update_Line property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Update_Line[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Line|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Update_Line
     */
    public function getAttributeName()
    {
        return 'Update_Line';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Line
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
