<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\EnumType;

/**
 * This class stands for CancelStatus EnumType
 * Meta information extracted from the WSDL
 * - documentation: Cancellation or lock status
 * - nillable: true
 * - type: tns:CancelStatus
 * @subpackage Enumerations
 */
class CancelStatus
{
    /**
     * Constant for value 'Locked'
     * Meta information extracted from the WSDL
     * - documentation: Locked order.
     * @return string 'Locked'
     */
    const VALUE_LOCKED = 'Locked';
    /**
     * Constant for value 'Canceled'
     * Meta information extracted from the WSDL
     * - documentation: Canceled order.
     * @return string 'Canceled'
     */
    const VALUE_CANCELED = 'Canceled';
    /**
     * Constant for value 'Unlocked'
     * Meta information extracted from the WSDL
     * - documentation: Released order.
     * @return string 'Unlocked'
     */
    const VALUE_UNLOCKED = 'Unlocked';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_LOCKED
     * @uses self::VALUE_CANCELED
     * @uses self::VALUE_UNLOCKED
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_LOCKED,
            self::VALUE_CANCELED,
            self::VALUE_UNLOCKED,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
