<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\EnumType;

/**
 * This class stands for UserFieldKind EnumType
 * Meta information extracted from the WSDL
 * - documentation: User-defined field type
 * - nillable: true
 * - type: tns:UserFieldKind
 * @subpackage Enumerations
 */
class UserFieldKind
{
    /**
     * Constant for value 'BooleanValueKind'
     * Meta information extracted from the WSDL
     * - documentation: Boolean.
     * @return string 'BooleanValueKind'
     */
    const VALUE_BOOLEAN_VALUE_KIND = 'BooleanValueKind';
    /**
     * Constant for value 'TextValueKind'
     * Meta information extracted from the WSDL
     * - documentation: String.
     * @return string 'TextValueKind'
     */
    const VALUE_TEXT_VALUE_KIND = 'TextValueKind';
    /**
     * Constant for value 'DateValueKind'
     * Meta information extracted from the WSDL
     * - documentation: Date.
     * @return string 'DateValueKind'
     */
    const VALUE_DATE_VALUE_KIND = 'DateValueKind';
    /**
     * Constant for value 'ListElementValueKind'
     * Meta information extracted from the WSDL
     * - documentation: Selection list.
     * @return string 'ListElementValueKind'
     */
    const VALUE_LIST_ELEMENT_VALUE_KIND = 'ListElementValueKind';
    /**
     * Constant for value 'NumberValueKind'
     * Meta information extracted from the WSDL
     * - documentation: Numerical.
     * @return string 'NumberValueKind'
     */
    const VALUE_NUMBER_VALUE_KIND = 'NumberValueKind';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_BOOLEAN_VALUE_KIND
     * @uses self::VALUE_TEXT_VALUE_KIND
     * @uses self::VALUE_DATE_VALUE_KIND
     * @uses self::VALUE_LIST_ELEMENT_VALUE_KIND
     * @uses self::VALUE_NUMBER_VALUE_KIND
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_BOOLEAN_VALUE_KIND,
            self::VALUE_TEXT_VALUE_KIND,
            self::VALUE_DATE_VALUE_KIND,
            self::VALUE_LIST_ELEMENT_VALUE_KIND,
            self::VALUE_NUMBER_VALUE_KIND,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
