<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Update ServiceType
 * @subpackage Services
 */
class Update extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named Update
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/04 - V1102] - Enables the modification of a sales document. Cancels and replaces the original document, thus keeping its identifiers. The document must not have any link with other documents. To update existent payment
     * received, use the UpdatePayments method.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateResponse|bool
     */
    public function Update(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->Update($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named UpdatePayments
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/04 - V1105] - Enables the modification of payments for a sales document.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePaymentsResponse|bool
     */
    public function UpdatePayments(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->UpdatePayments($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named UpdateHeader
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/04 - V1102] - Enables the modification of header elements in a sales document.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeaderResponse|bool
     */
    public function UpdateHeader(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->UpdateHeader($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeaderResponse|\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePaymentsResponse|\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
