<?php

namespace FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromReplyDocumentCollection StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromReplyDocumentCollection
 * @subpackage Structs
 */
class CreateFromReplyDocumentCollection extends AbstractStructBase
{
    /**
     * The Document
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocument[]
     */
    public $Document;
    /**
     * Constructor method for CreateFromReplyDocumentCollection
     * @uses CreateFromReplyDocumentCollection::setDocument()
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocument[] $document
     */
    public function __construct(array $document = array())
    {
        $this
            ->setDocument($document);
    }
    /**
     * Get Document value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocument[]|null
     */
    public function getDocument()
    {
        return isset($this->Document) ? $this->Document : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDocument method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDocument method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDocumentForArrayConstraintsFromSetDocument(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createFromReplyDocumentCollectionDocumentItem) {
            // validation for constraint: itemType
            if (!$createFromReplyDocumentCollectionDocumentItem instanceof \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocument) {
                $invalidValues[] = is_object($createFromReplyDocumentCollectionDocumentItem) ? get_class($createFromReplyDocumentCollectionDocumentItem) : sprintf('%s(%s)', gettype($createFromReplyDocumentCollectionDocumentItem), var_export($createFromReplyDocumentCollectionDocumentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Document property can only contain items of type \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocument, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Document value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocument[] $document
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocumentCollection
     */
    public function setDocument(array $document = array())
    {
        // validation for constraint: array
        if ('' !== ($documentArrayErrorMessage = self::validateDocumentForArrayConstraintsFromSetDocument($document))) {
            throw new \InvalidArgumentException($documentArrayErrorMessage, __LINE__);
        }
        if (is_null($document) || (is_array($document) && empty($document))) {
            unset($this->Document);
        } else {
            $this->Document = $document;
        }
        return $this;
    }
    /**
     * Add item to Document value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocument $item
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocumentCollection
     */
    public function addToDocument(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocument $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocument) {
            throw new \InvalidArgumentException(sprintf('The Document property can only contain items of type \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocument, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Document[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromReplyDocumentCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
