<?php

namespace FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromRequestHeader StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromRequestHeader
 * @subpackage Structs
 */
class CreateFromRequestHeader extends AbstractStructBase
{
    /**
     * The Date
     * @var string
     */
    public $Date;
    /**
     * The DeviceId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeviceId;
    /**
     * The DisableMergeLines
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $DisableMergeLines;
    /**
     * The DocumentTypeToCreate
     * @var string
     */
    public $DocumentTypeToCreate;
    /**
     * The InternalReference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InternalReference;
    /**
     * The Key
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderKey
     */
    public $Key;
    /**
     * The OperationUid
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OperationUid;
    /**
     * The RemainderManagement
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderRemainderManagement
     */
    public $RemainderManagement;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The SenderWarehouseId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SenderWarehouseId;
    /**
     * Constructor method for CreateFromRequestHeader
     * @uses CreateFromRequestHeader::setDate()
     * @uses CreateFromRequestHeader::setDeviceId()
     * @uses CreateFromRequestHeader::setDisableMergeLines()
     * @uses CreateFromRequestHeader::setDocumentTypeToCreate()
     * @uses CreateFromRequestHeader::setInternalReference()
     * @uses CreateFromRequestHeader::setKey()
     * @uses CreateFromRequestHeader::setOperationUid()
     * @uses CreateFromRequestHeader::setRemainderManagement()
     * @uses CreateFromRequestHeader::setSalesPersonId()
     * @uses CreateFromRequestHeader::setSenderWarehouseId()
     * @param string $date
     * @param string $deviceId
     * @param bool $disableMergeLines
     * @param string $documentTypeToCreate
     * @param string $internalReference
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderKey $key
     * @param string $operationUid
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderRemainderManagement $remainderManagement
     * @param string $salesPersonId
     * @param string $senderWarehouseId
     */
    public function __construct($date = null, $deviceId = null, $disableMergeLines = null, $documentTypeToCreate = null, $internalReference = null, \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderKey $key = null, $operationUid = null, \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderRemainderManagement $remainderManagement = null, $salesPersonId = null, $senderWarehouseId = null)
    {
        $this
            ->setDate($date)
            ->setDeviceId($deviceId)
            ->setDisableMergeLines($disableMergeLines)
            ->setDocumentTypeToCreate($documentTypeToCreate)
            ->setInternalReference($internalReference)
            ->setKey($key)
            ->setOperationUid($operationUid)
            ->setRemainderManagement($remainderManagement)
            ->setSalesPersonId($salesPersonId)
            ->setSenderWarehouseId($senderWarehouseId);
    }
    /**
     * Get Date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @param string $date
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeader
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Get DeviceId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeviceId()
    {
        return isset($this->DeviceId) ? $this->DeviceId : null;
    }
    /**
     * Set DeviceId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deviceId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeader
     */
    public function setDeviceId($deviceId = null)
    {
        // validation for constraint: string
        if (!is_null($deviceId) && !is_string($deviceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deviceId, true), gettype($deviceId)), __LINE__);
        }
        if (is_null($deviceId) || (is_array($deviceId) && empty($deviceId))) {
            unset($this->DeviceId);
        } else {
            $this->DeviceId = $deviceId;
        }
        return $this;
    }
    /**
     * Get DisableMergeLines value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getDisableMergeLines()
    {
        return isset($this->DisableMergeLines) ? $this->DisableMergeLines : null;
    }
    /**
     * Set DisableMergeLines value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $disableMergeLines
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeader
     */
    public function setDisableMergeLines($disableMergeLines = null)
    {
        // validation for constraint: boolean
        if (!is_null($disableMergeLines) && !is_bool($disableMergeLines)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($disableMergeLines, true), gettype($disableMergeLines)), __LINE__);
        }
        if (is_null($disableMergeLines) || (is_array($disableMergeLines) && empty($disableMergeLines))) {
            unset($this->DisableMergeLines);
        } else {
            $this->DisableMergeLines = $disableMergeLines;
        }
        return $this;
    }
    /**
     * Get DocumentTypeToCreate value
     * @return string|null
     */
    public function getDocumentTypeToCreate()
    {
        return $this->DocumentTypeToCreate;
    }
    /**
     * Set DocumentTypeToCreate value
     * @uses \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentTypeCreat::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentTypeCreat::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $documentTypeToCreate
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeader
     */
    public function setDocumentTypeToCreate($documentTypeToCreate = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentTypeCreat::valueIsValid($documentTypeToCreate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentTypeCreat', is_array($documentTypeToCreate) ? implode(', ', $documentTypeToCreate) : var_export($documentTypeToCreate, true), implode(', ', \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentTypeCreat::getValidValues())), __LINE__);
        }
        $this->DocumentTypeToCreate = $documentTypeToCreate;
        return $this;
    }
    /**
     * Get InternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInternalReference()
    {
        return isset($this->InternalReference) ? $this->InternalReference : null;
    }
    /**
     * Set InternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $internalReference
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeader
     */
    public function setInternalReference($internalReference = null)
    {
        // validation for constraint: string
        if (!is_null($internalReference) && !is_string($internalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($internalReference, true), gettype($internalReference)), __LINE__);
        }
        if (is_null($internalReference) || (is_array($internalReference) && empty($internalReference))) {
            unset($this->InternalReference);
        } else {
            $this->InternalReference = $internalReference;
        }
        return $this;
    }
    /**
     * Get Key value
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderKey|null
     */
    public function getKey()
    {
        return $this->Key;
    }
    /**
     * Set Key value
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderKey $key
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeader
     */
    public function setKey(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderKey $key = null)
    {
        $this->Key = $key;
        return $this;
    }
    /**
     * Get OperationUid value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOperationUid()
    {
        return isset($this->OperationUid) ? $this->OperationUid : null;
    }
    /**
     * Set OperationUid value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $operationUid
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeader
     */
    public function setOperationUid($operationUid = null)
    {
        // validation for constraint: string
        if (!is_null($operationUid) && !is_string($operationUid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($operationUid, true), gettype($operationUid)), __LINE__);
        }
        if (is_null($operationUid) || (is_array($operationUid) && empty($operationUid))) {
            unset($this->OperationUid);
        } else {
            $this->OperationUid = $operationUid;
        }
        return $this;
    }
    /**
     * Get RemainderManagement value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderRemainderManagement|null
     */
    public function getRemainderManagement()
    {
        return isset($this->RemainderManagement) ? $this->RemainderManagement : null;
    }
    /**
     * Set RemainderManagement value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderRemainderManagement $remainderManagement
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeader
     */
    public function setRemainderManagement(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeaderRemainderManagement $remainderManagement = null)
    {
        if (is_null($remainderManagement) || (is_array($remainderManagement) && empty($remainderManagement))) {
            unset($this->RemainderManagement);
        } else {
            $this->RemainderManagement = $remainderManagement;
        }
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeader
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get SenderWarehouseId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSenderWarehouseId()
    {
        return isset($this->SenderWarehouseId) ? $this->SenderWarehouseId : null;
    }
    /**
     * Set SenderWarehouseId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $senderWarehouseId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeader
     */
    public function setSenderWarehouseId($senderWarehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($senderWarehouseId) && !is_string($senderWarehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($senderWarehouseId, true), gettype($senderWarehouseId)), __LINE__);
        }
        if (is_null($senderWarehouseId) || (is_array($senderWarehouseId) && empty($senderWarehouseId))) {
            unset($this->SenderWarehouseId);
        } else {
            $this->SenderWarehouseId = $senderWarehouseId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestHeader
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
