<?php

namespace FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromRequestLine StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromRequestLine
 * @subpackage Structs
 */
class CreateFromRequestLine extends AbstractStructBase
{
    /**
     * The ItemIdentifier
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLineItemIdentifier
     */
    public $ItemIdentifier;
    /**
     * The LineId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $LineId;
    /**
     * The Quantity
     * @var float
     */
    public $Quantity;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The SenderWarehouseId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $SenderWarehouseId;
    /**
     * The SerialNumberId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SerialNumberId;
    /**
     * Constructor method for CreateFromRequestLine
     * @uses CreateFromRequestLine::setItemIdentifier()
     * @uses CreateFromRequestLine::setLineId()
     * @uses CreateFromRequestLine::setQuantity()
     * @uses CreateFromRequestLine::setSalesPersonId()
     * @uses CreateFromRequestLine::setSenderWarehouseId()
     * @uses CreateFromRequestLine::setSerialNumberId()
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLineItemIdentifier $itemIdentifier
     * @param int $lineId
     * @param float $quantity
     * @param string $salesPersonId
     * @param string $senderWarehouseId
     * @param string $serialNumberId
     */
    public function __construct(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLineItemIdentifier $itemIdentifier = null, $lineId = null, $quantity = null, $salesPersonId = null, $senderWarehouseId = null, $serialNumberId = null)
    {
        $this
            ->setItemIdentifier($itemIdentifier)
            ->setLineId($lineId)
            ->setQuantity($quantity)
            ->setSalesPersonId($salesPersonId)
            ->setSenderWarehouseId($senderWarehouseId)
            ->setSerialNumberId($serialNumberId);
    }
    /**
     * Get ItemIdentifier value
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLineItemIdentifier|null
     */
    public function getItemIdentifier()
    {
        return $this->ItemIdentifier;
    }
    /**
     * Set ItemIdentifier value
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLineItemIdentifier $itemIdentifier
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLine
     */
    public function setItemIdentifier(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLineItemIdentifier $itemIdentifier = null)
    {
        $this->ItemIdentifier = $itemIdentifier;
        return $this;
    }
    /**
     * Get LineId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getLineId()
    {
        return isset($this->LineId) ? $this->LineId : null;
    }
    /**
     * Set LineId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $lineId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLine
     */
    public function setLineId($lineId = null)
    {
        // validation for constraint: int
        if (!is_null($lineId) && !(is_int($lineId) || ctype_digit($lineId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lineId, true), gettype($lineId)), __LINE__);
        }
        if (is_null($lineId) || (is_array($lineId) && empty($lineId))) {
            unset($this->LineId);
        } else {
            $this->LineId = $lineId;
        }
        return $this;
    }
    /**
     * Get Quantity value
     * @return float|null
     */
    public function getQuantity()
    {
        return $this->Quantity;
    }
    /**
     * Set Quantity value
     * @param float $quantity
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLine
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: float
        if (!is_null($quantity) && !(is_float($quantity) || is_numeric($quantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->Quantity = $quantity;
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLine
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get SenderWarehouseId value
     * @return string|null
     */
    public function getSenderWarehouseId()
    {
        return $this->SenderWarehouseId;
    }
    /**
     * Set SenderWarehouseId value
     * @param string $senderWarehouseId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLine
     */
    public function setSenderWarehouseId($senderWarehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($senderWarehouseId) && !is_string($senderWarehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($senderWarehouseId, true), gettype($senderWarehouseId)), __LINE__);
        }
        $this->SenderWarehouseId = $senderWarehouseId;
        return $this;
    }
    /**
     * Get SerialNumberId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSerialNumberId()
    {
        return isset($this->SerialNumberId) ? $this->SerialNumberId : null;
    }
    /**
     * Set SerialNumberId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serialNumberId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLine
     */
    public function setSerialNumberId($serialNumberId = null)
    {
        // validation for constraint: string
        if (!is_null($serialNumberId) && !is_string($serialNumberId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serialNumberId, true), gettype($serialNumberId)), __LINE__);
        }
        if (is_null($serialNumberId) || (is_array($serialNumberId) && empty($serialNumberId))) {
            unset($this->SerialNumberId);
        } else {
            $this->SerialNumberId = $serialNumberId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateFromRequestLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
