<?php

namespace FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateRequestHeader StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateRequestHeader
 * @subpackage Structs
 */
class CreateRequestHeader extends AbstractStructBase
{
    /**
     * The CurrencyId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CurrencyId;
    /**
     * The Date
     * @var string
     */
    public $Date;
    /**
     * The DeviceId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeviceId;
    /**
     * The DisableMergeLines
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $DisableMergeLines;
    /**
     * The DocumentTypeToCreate
     * @var string
     */
    public $DocumentTypeToCreate;
    /**
     * The ExternalReference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ExternalReference;
    /**
     * The FollowUpReference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FollowUpReference;
    /**
     * The InternalReference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InternalReference;
    /**
     * The OperationUid
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OperationUid;
    /**
     * The Recipient
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderRecipient
     */
    public $Recipient;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The Sender
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderSender
     */
    public $Sender;
    /**
     * The TaxIncluded
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $TaxIncluded;
    /**
     * Constructor method for CreateRequestHeader
     * @uses CreateRequestHeader::setCurrencyId()
     * @uses CreateRequestHeader::setDate()
     * @uses CreateRequestHeader::setDeviceId()
     * @uses CreateRequestHeader::setDisableMergeLines()
     * @uses CreateRequestHeader::setDocumentTypeToCreate()
     * @uses CreateRequestHeader::setExternalReference()
     * @uses CreateRequestHeader::setFollowUpReference()
     * @uses CreateRequestHeader::setInternalReference()
     * @uses CreateRequestHeader::setOperationUid()
     * @uses CreateRequestHeader::setRecipient()
     * @uses CreateRequestHeader::setSalesPersonId()
     * @uses CreateRequestHeader::setSender()
     * @uses CreateRequestHeader::setTaxIncluded()
     * @param string $currencyId
     * @param string $date
     * @param string $deviceId
     * @param bool $disableMergeLines
     * @param string $documentTypeToCreate
     * @param string $externalReference
     * @param string $followUpReference
     * @param string $internalReference
     * @param string $operationUid
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderRecipient $recipient
     * @param string $salesPersonId
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderSender $sender
     * @param bool $taxIncluded
     */
    public function __construct($currencyId = null, $date = null, $deviceId = null, $disableMergeLines = null, $documentTypeToCreate = null, $externalReference = null, $followUpReference = null, $internalReference = null, $operationUid = null, \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderRecipient $recipient = null, $salesPersonId = null, \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderSender $sender = null, $taxIncluded = null)
    {
        $this
            ->setCurrencyId($currencyId)
            ->setDate($date)
            ->setDeviceId($deviceId)
            ->setDisableMergeLines($disableMergeLines)
            ->setDocumentTypeToCreate($documentTypeToCreate)
            ->setExternalReference($externalReference)
            ->setFollowUpReference($followUpReference)
            ->setInternalReference($internalReference)
            ->setOperationUid($operationUid)
            ->setRecipient($recipient)
            ->setSalesPersonId($salesPersonId)
            ->setSender($sender)
            ->setTaxIncluded($taxIncluded);
    }
    /**
     * Get CurrencyId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCurrencyId()
    {
        return isset($this->CurrencyId) ? $this->CurrencyId : null;
    }
    /**
     * Set CurrencyId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $currencyId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setCurrencyId($currencyId = null)
    {
        // validation for constraint: string
        if (!is_null($currencyId) && !is_string($currencyId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currencyId, true), gettype($currencyId)), __LINE__);
        }
        if (is_null($currencyId) || (is_array($currencyId) && empty($currencyId))) {
            unset($this->CurrencyId);
        } else {
            $this->CurrencyId = $currencyId;
        }
        return $this;
    }
    /**
     * Get Date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @param string $date
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Get DeviceId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeviceId()
    {
        return isset($this->DeviceId) ? $this->DeviceId : null;
    }
    /**
     * Set DeviceId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deviceId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setDeviceId($deviceId = null)
    {
        // validation for constraint: string
        if (!is_null($deviceId) && !is_string($deviceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deviceId, true), gettype($deviceId)), __LINE__);
        }
        if (is_null($deviceId) || (is_array($deviceId) && empty($deviceId))) {
            unset($this->DeviceId);
        } else {
            $this->DeviceId = $deviceId;
        }
        return $this;
    }
    /**
     * Get DisableMergeLines value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getDisableMergeLines()
    {
        return isset($this->DisableMergeLines) ? $this->DisableMergeLines : null;
    }
    /**
     * Set DisableMergeLines value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $disableMergeLines
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setDisableMergeLines($disableMergeLines = null)
    {
        // validation for constraint: boolean
        if (!is_null($disableMergeLines) && !is_bool($disableMergeLines)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($disableMergeLines, true), gettype($disableMergeLines)), __LINE__);
        }
        if (is_null($disableMergeLines) || (is_array($disableMergeLines) && empty($disableMergeLines))) {
            unset($this->DisableMergeLines);
        } else {
            $this->DisableMergeLines = $disableMergeLines;
        }
        return $this;
    }
    /**
     * Get DocumentTypeToCreate value
     * @return string|null
     */
    public function getDocumentTypeToCreate()
    {
        return $this->DocumentTypeToCreate;
    }
    /**
     * Set DocumentTypeToCreate value
     * @uses \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentTypeCreat::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentTypeCreat::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $documentTypeToCreate
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setDocumentTypeToCreate($documentTypeToCreate = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentTypeCreat::valueIsValid($documentTypeToCreate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentTypeCreat', is_array($documentTypeToCreate) ? implode(', ', $documentTypeToCreate) : var_export($documentTypeToCreate, true), implode(', ', \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentTypeCreat::getValidValues())), __LINE__);
        }
        $this->DocumentTypeToCreate = $documentTypeToCreate;
        return $this;
    }
    /**
     * Get ExternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExternalReference()
    {
        return isset($this->ExternalReference) ? $this->ExternalReference : null;
    }
    /**
     * Set ExternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $externalReference
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setExternalReference($externalReference = null)
    {
        // validation for constraint: string
        if (!is_null($externalReference) && !is_string($externalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalReference, true), gettype($externalReference)), __LINE__);
        }
        if (is_null($externalReference) || (is_array($externalReference) && empty($externalReference))) {
            unset($this->ExternalReference);
        } else {
            $this->ExternalReference = $externalReference;
        }
        return $this;
    }
    /**
     * Get FollowUpReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFollowUpReference()
    {
        return isset($this->FollowUpReference) ? $this->FollowUpReference : null;
    }
    /**
     * Set FollowUpReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $followUpReference
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setFollowUpReference($followUpReference = null)
    {
        // validation for constraint: string
        if (!is_null($followUpReference) && !is_string($followUpReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($followUpReference, true), gettype($followUpReference)), __LINE__);
        }
        if (is_null($followUpReference) || (is_array($followUpReference) && empty($followUpReference))) {
            unset($this->FollowUpReference);
        } else {
            $this->FollowUpReference = $followUpReference;
        }
        return $this;
    }
    /**
     * Get InternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInternalReference()
    {
        return isset($this->InternalReference) ? $this->InternalReference : null;
    }
    /**
     * Set InternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $internalReference
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setInternalReference($internalReference = null)
    {
        // validation for constraint: string
        if (!is_null($internalReference) && !is_string($internalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($internalReference, true), gettype($internalReference)), __LINE__);
        }
        if (is_null($internalReference) || (is_array($internalReference) && empty($internalReference))) {
            unset($this->InternalReference);
        } else {
            $this->InternalReference = $internalReference;
        }
        return $this;
    }
    /**
     * Get OperationUid value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOperationUid()
    {
        return isset($this->OperationUid) ? $this->OperationUid : null;
    }
    /**
     * Set OperationUid value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $operationUid
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setOperationUid($operationUid = null)
    {
        // validation for constraint: string
        if (!is_null($operationUid) && !is_string($operationUid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($operationUid, true), gettype($operationUid)), __LINE__);
        }
        if (is_null($operationUid) || (is_array($operationUid) && empty($operationUid))) {
            unset($this->OperationUid);
        } else {
            $this->OperationUid = $operationUid;
        }
        return $this;
    }
    /**
     * Get Recipient value
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderRecipient|null
     */
    public function getRecipient()
    {
        return $this->Recipient;
    }
    /**
     * Set Recipient value
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderRecipient $recipient
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setRecipient(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderRecipient $recipient = null)
    {
        $this->Recipient = $recipient;
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get Sender value
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderSender|null
     */
    public function getSender()
    {
        return $this->Sender;
    }
    /**
     * Set Sender value
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderSender $sender
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setSender(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeaderSender $sender = null)
    {
        $this->Sender = $sender;
        return $this;
    }
    /**
     * Get TaxIncluded value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getTaxIncluded()
    {
        return isset($this->TaxIncluded) ? $this->TaxIncluded : null;
    }
    /**
     * Set TaxIncluded value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $taxIncluded
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public function setTaxIncluded($taxIncluded = null)
    {
        // validation for constraint: boolean
        if (!is_null($taxIncluded) && !is_bool($taxIncluded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($taxIncluded, true), gettype($taxIncluded)), __LINE__);
        }
        if (is_null($taxIncluded) || (is_array($taxIncluded) && empty($taxIncluded))) {
            unset($this->TaxIncluded);
        } else {
            $this->TaxIncluded = $taxIncluded;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\CreateRequestHeader
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
