<?php

namespace FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DocumentKey StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DocumentKey
 * @subpackage Structs
 */
class DocumentKey extends AbstractStructBase
{
    /**
     * The Number
     * @var int
     */
    public $Number;
    /**
     * The Stub
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Stub;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * Constructor method for DocumentKey
     * @uses DocumentKey::setNumber()
     * @uses DocumentKey::setStub()
     * @uses DocumentKey::setType()
     * @param int $number
     * @param string $stub
     * @param string $type
     */
    public function __construct($number = null, $stub = null, $type = null)
    {
        $this
            ->setNumber($number)
            ->setStub($stub)
            ->setType($type);
    }
    /**
     * Get Number value
     * @return int|null
     */
    public function getNumber()
    {
        return $this->Number;
    }
    /**
     * Set Number value
     * @param int $number
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\DocumentKey
     */
    public function setNumber($number = null)
    {
        // validation for constraint: int
        if (!is_null($number) && !(is_int($number) || ctype_digit($number))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        $this->Number = $number;
        return $this;
    }
    /**
     * Get Stub value
     * @return string|null
     */
    public function getStub()
    {
        return $this->Stub;
    }
    /**
     * Set Stub value
     * @param string $stub
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\DocumentKey
     */
    public function setStub($stub = null)
    {
        // validation for constraint: string
        if (!is_null($stub) && !is_string($stub)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stub, true), gettype($stub)), __LINE__);
        }
        $this->Stub = $stub;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\DocumentKey
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentType::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\DocumentKey
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
