<?php

namespace FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetDetailReplyLine StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetDetailReplyLine
 * @subpackage Structs
 */
class GetDetailReplyLine extends AbstractStructBase
{
    /**
     * The BarCode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $BarCode;
    /**
     * The DeliveryDate
     * @var string
     */
    public $DeliveryDate;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Description;
    /**
     * The ItemCode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ItemCode;
    /**
     * The ItemId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ItemId;
    /**
     * The LineId
     * @var int
     */
    public $LineId;
    /**
     * The Quantity
     * @var float
     */
    public $Quantity;
    /**
     * The QuantityToPrepareForCustomers
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLineQuantityToPrepareForCustomers
     */
    public $QuantityToPrepareForCustomers;
    /**
     * The Rank
     * @var int
     */
    public $Rank;
    /**
     * The RemainingQuantity
     * @var float
     */
    public $RemainingQuantity;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The SerialNumberId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $SerialNumberId;
    /**
     * Constructor method for GetDetailReplyLine
     * @uses GetDetailReplyLine::setBarCode()
     * @uses GetDetailReplyLine::setDeliveryDate()
     * @uses GetDetailReplyLine::setDescription()
     * @uses GetDetailReplyLine::setItemCode()
     * @uses GetDetailReplyLine::setItemId()
     * @uses GetDetailReplyLine::setLineId()
     * @uses GetDetailReplyLine::setQuantity()
     * @uses GetDetailReplyLine::setQuantityToPrepareForCustomers()
     * @uses GetDetailReplyLine::setRank()
     * @uses GetDetailReplyLine::setRemainingQuantity()
     * @uses GetDetailReplyLine::setSalesPersonId()
     * @uses GetDetailReplyLine::setSerialNumberId()
     * @param string $barCode
     * @param string $deliveryDate
     * @param string $description
     * @param string $itemCode
     * @param string $itemId
     * @param int $lineId
     * @param float $quantity
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLineQuantityToPrepareForCustomers $quantityToPrepareForCustomers
     * @param int $rank
     * @param float $remainingQuantity
     * @param string $salesPersonId
     * @param string $serialNumberId
     */
    public function __construct($barCode = null, $deliveryDate = null, $description = null, $itemCode = null, $itemId = null, $lineId = null, $quantity = null, \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLineQuantityToPrepareForCustomers $quantityToPrepareForCustomers = null, $rank = null, $remainingQuantity = null, $salesPersonId = null, $serialNumberId = null)
    {
        $this
            ->setBarCode($barCode)
            ->setDeliveryDate($deliveryDate)
            ->setDescription($description)
            ->setItemCode($itemCode)
            ->setItemId($itemId)
            ->setLineId($lineId)
            ->setQuantity($quantity)
            ->setQuantityToPrepareForCustomers($quantityToPrepareForCustomers)
            ->setRank($rank)
            ->setRemainingQuantity($remainingQuantity)
            ->setSalesPersonId($salesPersonId)
            ->setSerialNumberId($serialNumberId);
    }
    /**
     * Get BarCode value
     * @return string|null
     */
    public function getBarCode()
    {
        return $this->BarCode;
    }
    /**
     * Set BarCode value
     * @param string $barCode
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setBarCode($barCode = null)
    {
        // validation for constraint: string
        if (!is_null($barCode) && !is_string($barCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($barCode, true), gettype($barCode)), __LINE__);
        }
        $this->BarCode = $barCode;
        return $this;
    }
    /**
     * Get DeliveryDate value
     * @return string|null
     */
    public function getDeliveryDate()
    {
        return $this->DeliveryDate;
    }
    /**
     * Set DeliveryDate value
     * @param string $deliveryDate
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setDeliveryDate($deliveryDate = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryDate) && !is_string($deliveryDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliveryDate, true), gettype($deliveryDate)), __LINE__);
        }
        $this->DeliveryDate = $deliveryDate;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get ItemCode value
     * @return string|null
     */
    public function getItemCode()
    {
        return $this->ItemCode;
    }
    /**
     * Set ItemCode value
     * @param string $itemCode
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setItemCode($itemCode = null)
    {
        // validation for constraint: string
        if (!is_null($itemCode) && !is_string($itemCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($itemCode, true), gettype($itemCode)), __LINE__);
        }
        $this->ItemCode = $itemCode;
        return $this;
    }
    /**
     * Get ItemId value
     * @return string|null
     */
    public function getItemId()
    {
        return $this->ItemId;
    }
    /**
     * Set ItemId value
     * @param string $itemId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setItemId($itemId = null)
    {
        // validation for constraint: string
        if (!is_null($itemId) && !is_string($itemId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($itemId, true), gettype($itemId)), __LINE__);
        }
        $this->ItemId = $itemId;
        return $this;
    }
    /**
     * Get LineId value
     * @return int|null
     */
    public function getLineId()
    {
        return $this->LineId;
    }
    /**
     * Set LineId value
     * @param int $lineId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setLineId($lineId = null)
    {
        // validation for constraint: int
        if (!is_null($lineId) && !(is_int($lineId) || ctype_digit($lineId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lineId, true), gettype($lineId)), __LINE__);
        }
        $this->LineId = $lineId;
        return $this;
    }
    /**
     * Get Quantity value
     * @return float|null
     */
    public function getQuantity()
    {
        return $this->Quantity;
    }
    /**
     * Set Quantity value
     * @param float $quantity
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: float
        if (!is_null($quantity) && !(is_float($quantity) || is_numeric($quantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->Quantity = $quantity;
        return $this;
    }
    /**
     * Get QuantityToPrepareForCustomers value
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLineQuantityToPrepareForCustomers|null
     */
    public function getQuantityToPrepareForCustomers()
    {
        return $this->QuantityToPrepareForCustomers;
    }
    /**
     * Set QuantityToPrepareForCustomers value
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLineQuantityToPrepareForCustomers $quantityToPrepareForCustomers
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setQuantityToPrepareForCustomers(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLineQuantityToPrepareForCustomers $quantityToPrepareForCustomers = null)
    {
        $this->QuantityToPrepareForCustomers = $quantityToPrepareForCustomers;
        return $this;
    }
    /**
     * Get Rank value
     * @return int|null
     */
    public function getRank()
    {
        return $this->Rank;
    }
    /**
     * Set Rank value
     * @param int $rank
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setRank($rank = null)
    {
        // validation for constraint: int
        if (!is_null($rank) && !(is_int($rank) || ctype_digit($rank))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($rank, true), gettype($rank)), __LINE__);
        }
        $this->Rank = $rank;
        return $this;
    }
    /**
     * Get RemainingQuantity value
     * @return float|null
     */
    public function getRemainingQuantity()
    {
        return $this->RemainingQuantity;
    }
    /**
     * Set RemainingQuantity value
     * @param float $remainingQuantity
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setRemainingQuantity($remainingQuantity = null)
    {
        // validation for constraint: float
        if (!is_null($remainingQuantity) && !(is_float($remainingQuantity) || is_numeric($remainingQuantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($remainingQuantity, true), gettype($remainingQuantity)), __LINE__);
        }
        $this->RemainingQuantity = $remainingQuantity;
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get SerialNumberId value
     * @return string|null
     */
    public function getSerialNumberId()
    {
        return $this->SerialNumberId;
    }
    /**
     * Set SerialNumberId value
     * @param string $serialNumberId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public function setSerialNumberId($serialNumberId = null)
    {
        // validation for constraint: string
        if (!is_null($serialNumberId) && !is_string($serialNumberId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serialNumberId, true), gettype($serialNumberId)), __LINE__);
        }
        $this->SerialNumberId = $serialNumberId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
