<?php

namespace FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetDetailReplyLineCollection StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetDetailReplyLineCollection
 * @subpackage Structs
 */
class GetDetailReplyLineCollection extends AbstractStructBase
{
    /**
     * The Line
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine[]
     */
    public $Line;
    /**
     * Constructor method for GetDetailReplyLineCollection
     * @uses GetDetailReplyLineCollection::setLine()
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine[] $line
     */
    public function __construct(array $line = array())
    {
        $this
            ->setLine($line);
    }
    /**
     * Get Line value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine[]|null
     */
    public function getLine()
    {
        return isset($this->Line) ? $this->Line : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLine method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLine method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLineForArrayConstraintsFromSetLine(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getDetailReplyLineCollectionLineItem) {
            // validation for constraint: itemType
            if (!$getDetailReplyLineCollectionLineItem instanceof \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine) {
                $invalidValues[] = is_object($getDetailReplyLineCollectionLineItem) ? get_class($getDetailReplyLineCollectionLineItem) : sprintf('%s(%s)', gettype($getDetailReplyLineCollectionLineItem), var_export($getDetailReplyLineCollectionLineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Line property can only contain items of type \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Line value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine[] $line
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLineCollection
     */
    public function setLine(array $line = array())
    {
        // validation for constraint: array
        if ('' !== ($lineArrayErrorMessage = self::validateLineForArrayConstraintsFromSetLine($line))) {
            throw new \InvalidArgumentException($lineArrayErrorMessage, __LINE__);
        }
        if (is_null($line) || (is_array($line) && empty($line))) {
            unset($this->Line);
        } else {
            $this->Line = $line;
        }
        return $this;
    }
    /**
     * Add item to Line value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine $item
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLineCollection
     */
    public function addToLine(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine) {
            throw new \InvalidArgumentException(sprintf('The Line property can only contain items of type \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLine, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Line[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetDetailReplyLineCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
