<?php

namespace FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetListDetailReplyTransferCollection StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetListDetailReplyTransferCollection
 * @subpackage Structs
 */
class GetListDetailReplyTransferCollection extends AbstractStructBase
{
    /**
     * The Transfer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransfer[]
     */
    public $Transfer;
    /**
     * Constructor method for GetListDetailReplyTransferCollection
     * @uses GetListDetailReplyTransferCollection::setTransfer()
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransfer[] $transfer
     */
    public function __construct(array $transfer = array())
    {
        $this
            ->setTransfer($transfer);
    }
    /**
     * Get Transfer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransfer[]|null
     */
    public function getTransfer()
    {
        return isset($this->Transfer) ? $this->Transfer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTransfer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransfer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransferForArrayConstraintsFromSetTransfer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getListDetailReplyTransferCollectionTransferItem) {
            // validation for constraint: itemType
            if (!$getListDetailReplyTransferCollectionTransferItem instanceof \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransfer) {
                $invalidValues[] = is_object($getListDetailReplyTransferCollectionTransferItem) ? get_class($getListDetailReplyTransferCollectionTransferItem) : sprintf('%s(%s)', gettype($getListDetailReplyTransferCollectionTransferItem), var_export($getListDetailReplyTransferCollectionTransferItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Transfer property can only contain items of type \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransfer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Transfer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransfer[] $transfer
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferCollection
     */
    public function setTransfer(array $transfer = array())
    {
        // validation for constraint: array
        if ('' !== ($transferArrayErrorMessage = self::validateTransferForArrayConstraintsFromSetTransfer($transfer))) {
            throw new \InvalidArgumentException($transferArrayErrorMessage, __LINE__);
        }
        if (is_null($transfer) || (is_array($transfer) && empty($transfer))) {
            unset($this->Transfer);
        } else {
            $this->Transfer = $transfer;
        }
        return $this;
    }
    /**
     * Add item to Transfer value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransfer $item
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferCollection
     */
    public function addToTransfer(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransfer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransfer) {
            throw new \InvalidArgumentException(sprintf('The Transfer property can only contain items of type \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransfer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Transfer[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
