<?php

namespace FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetListDetailReplyTransferHeader StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetListDetailReplyTransferHeader
 * @subpackage Structs
 */
class GetListDetailReplyTransferHeader extends AbstractStructBase
{
    /**
     * The DeliveryDate
     * @var string
     */
    public $DeliveryDate;
    /**
     * The DocumentDate
     * @var string
     */
    public $DocumentDate;
    /**
     * The EffectiveDate
     * @var string
     */
    public $EffectiveDate;
    /**
     * The ExternalReference
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ExternalReference;
    /**
     * The FollowUpReference
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $FollowUpReference;
    /**
     * The InternalReference
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $InternalReference;
    /**
     * The IsBeingModified
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IsBeingModified;
    /**
     * The Key
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\DocumentKey
     */
    public $Key;
    /**
     * The PresenceOfItemsForCustomers
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderPresenceOfItemsForCustomers
     */
    public $PresenceOfItemsForCustomers;
    /**
     * The Recipient
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderRecipient
     */
    public $Recipient;
    /**
     * The RemainingNumberOfItems
     * @var int
     */
    public $RemainingNumberOfItems;
    /**
     * The RemainingQuantity
     * @var float
     */
    public $RemainingQuantity;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The SenderWarehouseId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $SenderWarehouseId;
    /**
     * The TotalNumberOfItems
     * @var int
     */
    public $TotalNumberOfItems;
    /**
     * The TotalQuantity
     * @var float
     */
    public $TotalQuantity;
    /**
     * Constructor method for GetListDetailReplyTransferHeader
     * @uses GetListDetailReplyTransferHeader::setDeliveryDate()
     * @uses GetListDetailReplyTransferHeader::setDocumentDate()
     * @uses GetListDetailReplyTransferHeader::setEffectiveDate()
     * @uses GetListDetailReplyTransferHeader::setExternalReference()
     * @uses GetListDetailReplyTransferHeader::setFollowUpReference()
     * @uses GetListDetailReplyTransferHeader::setInternalReference()
     * @uses GetListDetailReplyTransferHeader::setIsBeingModified()
     * @uses GetListDetailReplyTransferHeader::setKey()
     * @uses GetListDetailReplyTransferHeader::setPresenceOfItemsForCustomers()
     * @uses GetListDetailReplyTransferHeader::setRecipient()
     * @uses GetListDetailReplyTransferHeader::setRemainingNumberOfItems()
     * @uses GetListDetailReplyTransferHeader::setRemainingQuantity()
     * @uses GetListDetailReplyTransferHeader::setSalesPersonId()
     * @uses GetListDetailReplyTransferHeader::setSenderWarehouseId()
     * @uses GetListDetailReplyTransferHeader::setTotalNumberOfItems()
     * @uses GetListDetailReplyTransferHeader::setTotalQuantity()
     * @param string $deliveryDate
     * @param string $documentDate
     * @param string $effectiveDate
     * @param string $externalReference
     * @param string $followUpReference
     * @param string $internalReference
     * @param bool $isBeingModified
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\DocumentKey $key
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderPresenceOfItemsForCustomers $presenceOfItemsForCustomers
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderRecipient $recipient
     * @param int $remainingNumberOfItems
     * @param float $remainingQuantity
     * @param string $salesPersonId
     * @param string $senderWarehouseId
     * @param int $totalNumberOfItems
     * @param float $totalQuantity
     */
    public function __construct($deliveryDate = null, $documentDate = null, $effectiveDate = null, $externalReference = null, $followUpReference = null, $internalReference = null, $isBeingModified = null, \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\DocumentKey $key = null, \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderPresenceOfItemsForCustomers $presenceOfItemsForCustomers = null, \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderRecipient $recipient = null, $remainingNumberOfItems = null, $remainingQuantity = null, $salesPersonId = null, $senderWarehouseId = null, $totalNumberOfItems = null, $totalQuantity = null)
    {
        $this
            ->setDeliveryDate($deliveryDate)
            ->setDocumentDate($documentDate)
            ->setEffectiveDate($effectiveDate)
            ->setExternalReference($externalReference)
            ->setFollowUpReference($followUpReference)
            ->setInternalReference($internalReference)
            ->setIsBeingModified($isBeingModified)
            ->setKey($key)
            ->setPresenceOfItemsForCustomers($presenceOfItemsForCustomers)
            ->setRecipient($recipient)
            ->setRemainingNumberOfItems($remainingNumberOfItems)
            ->setRemainingQuantity($remainingQuantity)
            ->setSalesPersonId($salesPersonId)
            ->setSenderWarehouseId($senderWarehouseId)
            ->setTotalNumberOfItems($totalNumberOfItems)
            ->setTotalQuantity($totalQuantity);
    }
    /**
     * Get DeliveryDate value
     * @return string|null
     */
    public function getDeliveryDate()
    {
        return $this->DeliveryDate;
    }
    /**
     * Set DeliveryDate value
     * @param string $deliveryDate
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setDeliveryDate($deliveryDate = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryDate) && !is_string($deliveryDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliveryDate, true), gettype($deliveryDate)), __LINE__);
        }
        $this->DeliveryDate = $deliveryDate;
        return $this;
    }
    /**
     * Get DocumentDate value
     * @return string|null
     */
    public function getDocumentDate()
    {
        return $this->DocumentDate;
    }
    /**
     * Set DocumentDate value
     * @param string $documentDate
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setDocumentDate($documentDate = null)
    {
        // validation for constraint: string
        if (!is_null($documentDate) && !is_string($documentDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentDate, true), gettype($documentDate)), __LINE__);
        }
        $this->DocumentDate = $documentDate;
        return $this;
    }
    /**
     * Get EffectiveDate value
     * @return string|null
     */
    public function getEffectiveDate()
    {
        return $this->EffectiveDate;
    }
    /**
     * Set EffectiveDate value
     * @param string $effectiveDate
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setEffectiveDate($effectiveDate = null)
    {
        // validation for constraint: string
        if (!is_null($effectiveDate) && !is_string($effectiveDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($effectiveDate, true), gettype($effectiveDate)), __LINE__);
        }
        $this->EffectiveDate = $effectiveDate;
        return $this;
    }
    /**
     * Get ExternalReference value
     * @return string|null
     */
    public function getExternalReference()
    {
        return $this->ExternalReference;
    }
    /**
     * Set ExternalReference value
     * @param string $externalReference
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setExternalReference($externalReference = null)
    {
        // validation for constraint: string
        if (!is_null($externalReference) && !is_string($externalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalReference, true), gettype($externalReference)), __LINE__);
        }
        $this->ExternalReference = $externalReference;
        return $this;
    }
    /**
     * Get FollowUpReference value
     * @return string|null
     */
    public function getFollowUpReference()
    {
        return $this->FollowUpReference;
    }
    /**
     * Set FollowUpReference value
     * @param string $followUpReference
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setFollowUpReference($followUpReference = null)
    {
        // validation for constraint: string
        if (!is_null($followUpReference) && !is_string($followUpReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($followUpReference, true), gettype($followUpReference)), __LINE__);
        }
        $this->FollowUpReference = $followUpReference;
        return $this;
    }
    /**
     * Get InternalReference value
     * @return string|null
     */
    public function getInternalReference()
    {
        return $this->InternalReference;
    }
    /**
     * Set InternalReference value
     * @param string $internalReference
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setInternalReference($internalReference = null)
    {
        // validation for constraint: string
        if (!is_null($internalReference) && !is_string($internalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($internalReference, true), gettype($internalReference)), __LINE__);
        }
        $this->InternalReference = $internalReference;
        return $this;
    }
    /**
     * Get IsBeingModified value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIsBeingModified()
    {
        return isset($this->IsBeingModified) ? $this->IsBeingModified : null;
    }
    /**
     * Set IsBeingModified value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $isBeingModified
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setIsBeingModified($isBeingModified = null)
    {
        // validation for constraint: boolean
        if (!is_null($isBeingModified) && !is_bool($isBeingModified)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isBeingModified, true), gettype($isBeingModified)), __LINE__);
        }
        if (is_null($isBeingModified) || (is_array($isBeingModified) && empty($isBeingModified))) {
            unset($this->IsBeingModified);
        } else {
            $this->IsBeingModified = $isBeingModified;
        }
        return $this;
    }
    /**
     * Get Key value
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\DocumentKey|null
     */
    public function getKey()
    {
        return $this->Key;
    }
    /**
     * Set Key value
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\DocumentKey $key
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setKey(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\DocumentKey $key = null)
    {
        $this->Key = $key;
        return $this;
    }
    /**
     * Get PresenceOfItemsForCustomers value
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderPresenceOfItemsForCustomers|null
     */
    public function getPresenceOfItemsForCustomers()
    {
        return $this->PresenceOfItemsForCustomers;
    }
    /**
     * Set PresenceOfItemsForCustomers value
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderPresenceOfItemsForCustomers $presenceOfItemsForCustomers
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setPresenceOfItemsForCustomers(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderPresenceOfItemsForCustomers $presenceOfItemsForCustomers = null)
    {
        $this->PresenceOfItemsForCustomers = $presenceOfItemsForCustomers;
        return $this;
    }
    /**
     * Get Recipient value
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderRecipient|null
     */
    public function getRecipient()
    {
        return $this->Recipient;
    }
    /**
     * Set Recipient value
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderRecipient $recipient
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setRecipient(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeaderRecipient $recipient = null)
    {
        $this->Recipient = $recipient;
        return $this;
    }
    /**
     * Get RemainingNumberOfItems value
     * @return int|null
     */
    public function getRemainingNumberOfItems()
    {
        return $this->RemainingNumberOfItems;
    }
    /**
     * Set RemainingNumberOfItems value
     * @param int $remainingNumberOfItems
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setRemainingNumberOfItems($remainingNumberOfItems = null)
    {
        // validation for constraint: int
        if (!is_null($remainingNumberOfItems) && !(is_int($remainingNumberOfItems) || ctype_digit($remainingNumberOfItems))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($remainingNumberOfItems, true), gettype($remainingNumberOfItems)), __LINE__);
        }
        $this->RemainingNumberOfItems = $remainingNumberOfItems;
        return $this;
    }
    /**
     * Get RemainingQuantity value
     * @return float|null
     */
    public function getRemainingQuantity()
    {
        return $this->RemainingQuantity;
    }
    /**
     * Set RemainingQuantity value
     * @param float $remainingQuantity
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setRemainingQuantity($remainingQuantity = null)
    {
        // validation for constraint: float
        if (!is_null($remainingQuantity) && !(is_float($remainingQuantity) || is_numeric($remainingQuantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($remainingQuantity, true), gettype($remainingQuantity)), __LINE__);
        }
        $this->RemainingQuantity = $remainingQuantity;
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get SenderWarehouseId value
     * @return string|null
     */
    public function getSenderWarehouseId()
    {
        return $this->SenderWarehouseId;
    }
    /**
     * Set SenderWarehouseId value
     * @param string $senderWarehouseId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setSenderWarehouseId($senderWarehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($senderWarehouseId) && !is_string($senderWarehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($senderWarehouseId, true), gettype($senderWarehouseId)), __LINE__);
        }
        $this->SenderWarehouseId = $senderWarehouseId;
        return $this;
    }
    /**
     * Get TotalNumberOfItems value
     * @return int|null
     */
    public function getTotalNumberOfItems()
    {
        return $this->TotalNumberOfItems;
    }
    /**
     * Set TotalNumberOfItems value
     * @param int $totalNumberOfItems
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setTotalNumberOfItems($totalNumberOfItems = null)
    {
        // validation for constraint: int
        if (!is_null($totalNumberOfItems) && !(is_int($totalNumberOfItems) || ctype_digit($totalNumberOfItems))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($totalNumberOfItems, true), gettype($totalNumberOfItems)), __LINE__);
        }
        $this->TotalNumberOfItems = $totalNumberOfItems;
        return $this;
    }
    /**
     * Get TotalQuantity value
     * @return float|null
     */
    public function getTotalQuantity()
    {
        return $this->TotalQuantity;
    }
    /**
     * Set TotalQuantity value
     * @param float $totalQuantity
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public function setTotalQuantity($totalQuantity = null)
    {
        // validation for constraint: float
        if (!is_null($totalQuantity) && !(is_float($totalQuantity) || is_numeric($totalQuantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($totalQuantity, true), gettype($totalQuantity)), __LINE__);
        }
        $this->TotalQuantity = $totalQuantity;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailReplyTransferHeader
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
