<?php

namespace FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetListDetailRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetListDetailRequest
 * @subpackage Structs
 */
class GetListDetailRequest extends AbstractStructBase
{
    /**
     * The DocumentTypeId
     * @var string
     */
    public $DocumentTypeId;
    /**
     * The ExtractByOldest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $ExtractByOldest;
    /**
     * The Paging
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\Paging
     */
    public $Paging;
    /**
     * The SearchDate
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequestSearchDate
     */
    public $SearchDate;
    /**
     * The SenderStoreId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $SenderStoreId;
    /**
     * Constructor method for GetListDetailRequest
     * @uses GetListDetailRequest::setDocumentTypeId()
     * @uses GetListDetailRequest::setExtractByOldest()
     * @uses GetListDetailRequest::setPaging()
     * @uses GetListDetailRequest::setSearchDate()
     * @uses GetListDetailRequest::setSenderStoreId()
     * @param string $documentTypeId
     * @param bool $extractByOldest
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\Paging $paging
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequestSearchDate $searchDate
     * @param string $senderStoreId
     */
    public function __construct($documentTypeId = null, $extractByOldest = null, \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\Paging $paging = null, \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequestSearchDate $searchDate = null, $senderStoreId = null)
    {
        $this
            ->setDocumentTypeId($documentTypeId)
            ->setExtractByOldest($extractByOldest)
            ->setPaging($paging)
            ->setSearchDate($searchDate)
            ->setSenderStoreId($senderStoreId);
    }
    /**
     * Get DocumentTypeId value
     * @return string|null
     */
    public function getDocumentTypeId()
    {
        return $this->DocumentTypeId;
    }
    /**
     * Set DocumentTypeId value
     * @uses \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $documentTypeId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequest
     */
    public function setDocumentTypeId($documentTypeId = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentType::valueIsValid($documentTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentType', is_array($documentTypeId) ? implode(', ', $documentTypeId) : var_export($documentTypeId, true), implode(', ', \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\EnumType\ItemsDeliveryDocumentType::getValidValues())), __LINE__);
        }
        $this->DocumentTypeId = $documentTypeId;
        return $this;
    }
    /**
     * Get ExtractByOldest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getExtractByOldest()
    {
        return isset($this->ExtractByOldest) ? $this->ExtractByOldest : null;
    }
    /**
     * Set ExtractByOldest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $extractByOldest
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequest
     */
    public function setExtractByOldest($extractByOldest = null)
    {
        // validation for constraint: boolean
        if (!is_null($extractByOldest) && !is_bool($extractByOldest)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($extractByOldest, true), gettype($extractByOldest)), __LINE__);
        }
        if (is_null($extractByOldest) || (is_array($extractByOldest) && empty($extractByOldest))) {
            unset($this->ExtractByOldest);
        } else {
            $this->ExtractByOldest = $extractByOldest;
        }
        return $this;
    }
    /**
     * Get Paging value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\Paging|null
     */
    public function getPaging()
    {
        return isset($this->Paging) ? $this->Paging : null;
    }
    /**
     * Set Paging value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\Paging $paging
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequest
     */
    public function setPaging(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\Paging $paging = null)
    {
        if (is_null($paging) || (is_array($paging) && empty($paging))) {
            unset($this->Paging);
        } else {
            $this->Paging = $paging;
        }
        return $this;
    }
    /**
     * Get SearchDate value
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequestSearchDate|null
     */
    public function getSearchDate()
    {
        return $this->SearchDate;
    }
    /**
     * Set SearchDate value
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequestSearchDate $searchDate
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequest
     */
    public function setSearchDate(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequestSearchDate $searchDate = null)
    {
        $this->SearchDate = $searchDate;
        return $this;
    }
    /**
     * Get SenderStoreId value
     * @return string|null
     */
    public function getSenderStoreId()
    {
        return $this->SenderStoreId;
    }
    /**
     * Set SenderStoreId value
     * @param string $senderStoreId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequest
     */
    public function setSenderStoreId($senderStoreId = null)
    {
        // validation for constraint: string
        if (!is_null($senderStoreId) && !is_string($senderStoreId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($senderStoreId, true), gettype($senderStoreId)), __LINE__);
        }
        $this->SenderStoreId = $senderStoreId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\GetListDetailRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
