<?php

namespace FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RefuseRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:RefuseRequest
 * @subpackage Structs
 */
class RefuseRequest extends AbstractStructBase
{
    /**
     * The Key
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\RefuseRequestKey
     */
    public $Key;
    /**
     * The ReasonId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ReasonId;
    /**
     * Constructor method for RefuseRequest
     * @uses RefuseRequest::setKey()
     * @uses RefuseRequest::setReasonId()
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\RefuseRequestKey $key
     * @param string $reasonId
     */
    public function __construct(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\RefuseRequestKey $key = null, $reasonId = null)
    {
        $this
            ->setKey($key)
            ->setReasonId($reasonId);
    }
    /**
     * Get Key value
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\RefuseRequestKey|null
     */
    public function getKey()
    {
        return $this->Key;
    }
    /**
     * Set Key value
     * @param \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\RefuseRequestKey $key
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\RefuseRequest
     */
    public function setKey(\FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\RefuseRequestKey $key = null)
    {
        $this->Key = $key;
        return $this;
    }
    /**
     * Get ReasonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReasonId()
    {
        return isset($this->ReasonId) ? $this->ReasonId : null;
    }
    /**
     * Set ReasonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $reasonId
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\RefuseRequest
     */
    public function setReasonId($reasonId = null)
    {
        // validation for constraint: string
        if (!is_null($reasonId) && !is_string($reasonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reasonId, true), gettype($reasonId)), __LINE__);
        }
        if (is_null($reasonId) || (is_array($reasonId) && empty($reasonId))) {
            unset($this->ReasonId);
        } else {
            $this->ReasonId = $reasonId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\TransferItemsDeliveryManagementService\StructType\RefuseRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
